/*****************************************************************************
    uginfo.c

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <grp.h>
#include "getarg.h"

int isaNumber (char *txt)
{
    int first;

    for (first=1; *txt != '\0'; txt++, first=0) {
        if (first && (*txt == '-')) continue;
        if ((*txt >= '0') && (*txt <= '9')) continue;
        return 0;
    }
    return 1;
}


int main (int argc, char **argv)
{
    char *allopts = "vUuGg";
    int un, ui, gn, gi, vb;
    char *va;
    struct passwd *p;
    struct group *g;

    un = atoi(getarg(argc,argv,allopts,'U',"1","0"));
    ui = atoi(getarg(argc,argv,allopts,'u',"1","0"));
    gn = atoi(getarg(argc,argv,allopts,'G',"1","0"));
    gi = atoi(getarg(argc,argv,allopts,'g',"1","0"));
    vb = atoi(getarg(argc,argv,allopts,'v',"1","0"));
    va =      getarg(argc,argv,allopts, -1,NULL,NULL);

    if (va == NULL) {
        fprintf (stderr,
                 "Usage is: uginfo [-U] [-u] [-G] [-g] [-v] name_or_id\n");
        return 1;
    }

    if (un | ui) {
        if ((p=getpwnam(va)) == NULL) {
            if ((!isaNumber(va)) ||
                ((p=getpwuid((uid_t)atoi(va))) == NULL)) {
                if (vb)
                    fprintf (stderr, "Unknown user name or UID: %s\n", va);
                return 1;
            }
        }
        if (un)
            printf ("%s", p->pw_name);
        if (un && ui)
            printf (" ");
        if (ui)
            printf ("%d", p->pw_uid);
        printf ("\n");
    }

    if (gn | gi) {
        if ((g=getgrnam(va)) == NULL) {
            if ((!isaNumber(va)) ||
                ((g=getgrgid((gid_t)atoi(va))) == NULL)) {
                if (vb)
                    fprintf (stderr, "Unknown group name or GID: %s\n", va);
                return 1;
            }
        }
        if (gn)
            printf ("%s", g->gr_name);
        if (gn && gi)
            printf (" ");
        if (gi)
            printf ("%d", g->gr_gid);
        printf ("\n");
    }
    return 0;
}
